<template>
  <dialog-card :title="$t('dialogs.analysis-upload.title')" :actions="actions">
    <v-card-text class="keep-line-breaks">
      {{ $t('dialogs.analysis-upload.info.save') }}
    </v-card-text>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-text-field
        v-model="name" name="name"
        :label="$t('dialogs.analysis-upload.label.analysis')"
        :rules="[
          v => !!v || 'Name is required',
          v => (typeof v === 'string' && !!v.match(/^[0-9a-zA-Z\ \-\_]+$/))
            || 'Name must be alphanumerical',
        ]"
        required
      />
    </v-form>
  </dialog-card>
</template>

<script lang="ts">
import {
  Vue, Component, Prop,
} from 'vue-property-decorator';
import { ClientStatus } from '@/client';
import type { Client } from '@/client';
import { trimAnalysisName } from '@/vuejs/components/utils/nav-tools';
import type { Analysis } from '@/data';

@Component
export default class UploadDialog extends Vue {
  loading = false;

  name = '';

  errorMessage: string | null = null;

  valid = true;

  get actions() {
    return {
      cancel: {
        text: 'Cancel',
        handle: this.close,
      },
      upload: {
        loading: this.loading,
        text: 'Upload',
        handle: this.upload,
        disabled: !this.valid,
      },
    };
  }

  @Prop()
  client!: Client;

  @Prop()
  piecePath!: string;

  @Prop()
  analysis!: Analysis;

  mounted() {
    const name = this.analysis.fileName;
    this.name = name ? trimAnalysisName(name) : '';
  }

  async upload(): Promise<string | ClientStatus> {
    const name = `${this.name}.dez`;
    const res = await this.client.uploadAnalysis(
      this.piecePath,
      name,
      this.analysis,
    );

    if (res.status === ClientStatus.Ok) {
      return name;
    }
    return res.status;
  }

  // upload function
  // chose when to display
  // this or caller must have access to current analysis and current analysis name if exist
  // this or caller must able to reroute to the now correct addr without reload
  // show loading

  close() {
    this.$emit('submit', false);
  }
}
</script>
<style scoped lang="scss">
.keep-line-breaks {
  white-space: pre-line
}
</style>
